#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# editor: mufei(ypdh@qq.com tel:15712150708)
'''
牧飞 _ __ ___   ___   ___  / _| ___(_)
| '_ ` _ \ / _ \ / _ \| |_ / _ \ |
| | | | | | (_) | (_) |  _|  __/ |
|_| |_| |_|\___/ \___/|_|  \___|_|
'''
#+--------------------------------------------------------------------
#|   宝塔第三方应用开发 mfwaf
#+--------------------------------------------------------------------

#本代码使用GPL协议，解释权归牧飞(ypdh@qq.com)所有。

#本插件需要在/www/server/nginx/conf/nginx.conf配置文件中添加 include mfngxwaf.conf 

import re
import sys
import os
import time
import json
from IPy import IP
wafpath = '/www/server/nginx/mfwaf' #
SendDataLen = 0



if sys.version_info[0] == 2:
    try:
        from cStringIO import StringIO
    except:
        from StringIO import StringIO
else:
    from io import BytesIO as StringIO
    

from vilidate import vie, vieCode
mfwaflog = "/www/server/nginx/mfwaf/mfwaf.log"
from ipcheck import isChinaIP
import traceback

ipzhizhutxtpath = os.path.join(wafpath, 'conf', 'ipzhizhu.txt')

logfile = open(mfwaflog,'a+') #a+

with open(os.path.join(wafpath,'conf','captcha.png'),'rb') as f:
    TmpPng = f.read()

from urllib import urlencode, quote as urlquote, unquote as urlunquote

def _parse_qsl(qs):
    r = []
    for pair in qs.replace(';','&').split('&'):
        if not pair: continue
        nv = pair.split('=', 1)
        if len(nv) != 2: nv.append('')
        key = urlunquote(nv[0].replace('+', ' '))
        value = urlunquote(nv[1].replace('+', ' '))
        r.append((key, value))
    return r


_cookiePattern = re.compile(
    r"(?x)"                       # Verbose pattern
    r"[,\ ]*"                        # space/comma (RFC2616 4.2) before attr-val is eaten
    r"(?P<key>"                   # Start of group 'key'
    r"[^;\ =]+"                     # anything but ';', ' ' or '='
    r")"                          # End of group 'key'
    r"\ *(=\ *)?"                 # a space, then may be "=", more space
    r"(?P<val>"                   # Start of group 'val'
    r'"(?:[^\\"]|\\.)*"'            # a doublequoted string
    r"|"                            # or
    r"[^;]*"                        # any word or empty string
    r")"                          # End of group 'val'
    r"\s*;?"                      # probably ending in a semi-colon
    )

def _parse_cookie(str, names=None):
    # XXX problem is we should allow duplicate
    # strings
    result = {}

    matchIter = _cookiePattern.finditer(str)

    for match in matchIter:
        key, val = match.group("key"), match.group("val")

        # We just ditch the cookies names which start with a dollar sign since
        # those are in fact RFC2965 cookies attributes. See bug [#MODPYTHON-3].
        if key[0]!='$' and (names is None or key in names):
            result[key] = val

    return result


def readTxt(path):
    if not os.path.isfile(path):
        return []
    with open(path,'r') as f:
        txt = f.read()
    txt = re.sub(r'<!--[\s\S]*?-->', '\n', txt)
    L = []
    for line in txt.split('\n'):
        s = line.split('#')[0].strip()
        if s: L.append(s)
    return L


int_ip = lambda x: '.'.join([str(x/(256**i)%256) for i in range(3,-1,-1)])
ip_int = lambda x:sum([256**j*int(i) for j,i in enumerate(x.split('.')[::-1])])
def readIpTxt(path, d=None):
    L = readTxt(path)
    if not L: return {}
    if d is None: d = {}
    for s in L:
        if s[0]=='(': s=s[1:-1]
        if '|' in s:
            ss = s.split('|')
        else:
            ss = [s]
        for e in ss:
            if '-' in e:
                ip1,ip2 = e.split('-', 1)
                try:
                    ip1_num = ip_int(ip1.strip())
                    ip2_num = ip_int(ip2.strip())
                    for i in range(ip1_num,ip2_num+1): d[int_ip(i)]= 1
                except:
                    logfile.write(path+' '+str(e)+' error 0\n')
                    print(traceback.format_exc())
            else:
                try:
                    for ip in IP(e): d[str(ip)] = 1
                except:
                    logfile.write(path+' '+str(e)+' error 1\n')
                    print(traceback.format_exc())
    return d


def readReTxt(path):
    L = readTxt(path)
    if not L: return []
    _L = []
    for s in L:
        try:
            re.search(s,'')
            _L.append(s)
        except:
            pass
    return _L


def readIpListTxt(path, d=None):
    L = readTxt(path)
    if d is None: d = cIP()
    if not L: return d
    for s in L:
        if s[0]=='(': s=s.strip()[1:-1]
        if '|' in s:
            ss = s.split('|')
        else:
            ss = [s]
        for e in ss:
            try:
                d.add(e, istry=1)
            except:
                logfile.write(path+' '+str(e)+' error 1\n')
                print(traceback.format_exc())
    return d



class cIP(object):
    def __init__(self): 
        self.__dict = {}
        self.__list = []
        self.__dict6 = {}
        self.__list6 = []
        
    def __nonzero__(self):
        return self.__dict or self.__list

    def __contains__(self, key):
        if isinstance (key,str):
            if ':' in key:
                if key in self.__dict6: return True
                for k in self.__list6:
                    if k[1]>=key>=k[0]:
                        return True
                return False
            key = ip_int(key)
        if key in self.__dict:
            return True
        for k in self.__list:
            if k[1]>=key>=k[0]:
                return True
        return False

    #def __delitem__(self, key): del self._d[key]
    
    def __getitem__(self, key, default=None):
        if isinstance (key,str):
            if ':' in key:
                if key in self.__dict6:
                    return self.__dict6[key]
                for k in self.__list6:
                    if k[1]>=key>=k[0]:
                        return 1
                return default
            key = ip_int(key)
        if key in self.__dict:
            return self.__dict[key]
        for k in self.__list:
            if k[1]>=key>=k[0]:
                return 1
        return default
    get = __getitem__
    
    def __setitem__(self, key, value):
        if isinstance (key,str):
            if ':' in key:
                self.__dict6[key]=value
                return
            key = ip_int(key)
        if value is None:
            self.__dict.pop(key,value)
        else:
            self.__dict[key]=value


    def add(self, ip, istry=0):
        ip = ip.replace(' ','')
        if istry:
            if '*' in ip:
                i = [32,24,16,8][ip.count('*')]
                ip = ip.replace('*','0')+'/%d'%i
            elif ip.endswith('.'):
                i = ip.count('.')
                if i==1:
                    ip = ip+'0.0.0/8'
                elif i==2:
                    ip = ip+'0.0/16'
                elif i==3:
                    ip = ip+'0/24'
        
        if ':' in ip:
            if '/' in ip:
                ips = IP(ip)
                ip1,ip2 = str(ips[0]), str(ips[-1])
                self.__list6.append((ip1,ip2))
            else:
                self.__dict6[ip] = 1
            
        elif '-' in ip:
            ip1,ip2 = ip.split('-', 1)
            ip1 = ip_int(ip1)
            ip2 = ip_int(ip2)
            if ip1>ip2: ip1,ip2 = ip2, ip1
            self.__list.append((ip1,ip2))
        elif '/' in ip:
            ips = IP(ip)
            ip1,ip2 = str(ips[0]), str(ips[-1])
            ip1 = ip_int(ip1)
            ip2 = ip_int(ip2)
            if ip1>ip2: ip1,ip2 = ip2, ip1
            self.__list.append((ip1,ip2))
        else:
            ip0 = ip_int(ip)
            self.__dict[ip0] = 1
    def json(self):
        return {'ip4_dict':self.__dict,'ip4_list':self.__list, 'ip6_list':self.__list6, 'ip6_dict':self.__dict6}  

    @classmethod
    def dumps(cls, cfg, *args, **awgs):
        def default(obj):  
            if isinstance(obj, cls):  
                return obj.json()
        awgs.setdefault('default', default)
        return json.dumps(cfg, *args,**awgs)



def log(r, ip, msg=''):
    host = r.var['host']
    info = '%s - [%s] - %s - "%s" - %s\n'%(ip, time.ctime(), host, r.var['request'], msg) 
    logfile.write(info)
    logfile.flush() #?????


def isAbroad(r,ip, cache={}):
    if ip.startswith(('127','10.','192.168')):
        return False
    cache[ip] = not isChinaIP(ip)
    return cache[ip]


def mfwaf_file(r,uri):
    path = os.path.join(wafpath,uri[7:])
    if os.path.isfile(path):
        s = open(path,'rb').read()
        if SendDataLen: r.ho['Content-Length'] = len(s)
        if path.endswith('.html'):
            r.ho['Content-Type'] = 'text/html; charset=utf-8'
        elif path.endswith('.js'):
            r.ho['Content-Type'] = 'application/javascript'
        elif path.endswith(('.gif','.png','.jpg')):
            r.ho['Content-Type'] = 'image/'+path[-3:]
        #r.ho['Content-Encoding'] = 'no'
        #r.ho['Transfer-Encoding'] = 'no'
        #r.hi['Connection'] = 'close'
        #r.ho['Transfer-Encoding'] = None
        r.status = 200
    else:
        s = ""
        r.status = 503
        r.ho['Mf-Waf-Msg'] = uri+" no file"
        if SendDataLen: r.ho['Content-Length'] = 0
        
    r.sendHeader()
    r.send(s, 1)
    return 






