#!/usr/bin/python
# -*- coding: UTF-8 -*-
# editor: moofei
'''
QQ53133259: 牧飞 _ __ ___   ___   ___  / _| ___(_)
| '_ ` _ \ / _ \ / _ \| |_ / _ \ |
| | | | | | (_) | (_) |  _|  __/ |
|_| |_| |_|\___/ \___/|_|  \___|_|
'''

#pip install Cython
#python func_setup.py build_ext  --inplace
#python func_setup.py func.py

#如果你想指定其他的编译器，或者前面没有添加distutils.cfg文件，可以在命令行指定
#如，指定Mingw32 。注意inplace 和compiler前有两个”– –”
#python setup.py build_ext – –inplace – –compiler=mingw32
#如果是VS编译器参考
#python setup.py build_ext – –inplace – –compiler=msvc

try:
    from setuptools import setup,Extension
except ImportError:
    #from distutils.core import setup
    #from distutils.extension import Extension
    from distutils.core import setup,Extension #这个好像不太行



from Cython.Build import cythonize
import os, sys

isclear = 0
if '--clear' in sys.argv:
    sys.argv.remove('--clear')
    isclear = 1


nosetup = 0
if '--nosetup' in sys.argv:
    sys.argv.remove('--nosetup')
    nosetup = 1

def main(path=None, version = '1.0', description = 'by MuFei QQ:53133259',):
    if path is None:
        if len(sys.argv)==2: path = sys.argv[1]
        sys.argv = sys.argv[:1]+['build_ext',  '--inplace']
    path,_file = os.path.split(path)
    name = _file.split('.')[0]
    
    if _file.endswith('.c'):
        if isclear:
            tmp = re.sub("\n\s*/[*][\s\S]*?[*]\/", clearMemo, open(_file).read())
            open(_file,'w').write(tmp)
            if nosetup: sys.exit()
        module1 = Extension(name=name, sources = [_file])
        setup (name = name, version=version, description=description, ext_modules = [module1])
    else:
        setup(
          name = name,
          ext_modules = cythonize(_file),
          version=version, description=description
        )


import re    
def clearMemo(m):
    ss =  m.group()
    L = []
    for s in ss.split('\n'):
        _s = s.strip()
        if not _s:
            L.append(s)
        elif _s.startswith('/*') or _s.endswith('*/'):
            L.append(_s)
        else:
            L.append(' *')
    rs = '\n'.join(L)
    print(rs)
    return rs
    


if __name__ == "__main__":
    main()


