#!/usr/bin/python
# -*- coding: UTF-8 -*-
# editor: moofei


import os

__all__ = ['isChinaIP']

global_ip_dict = [[[] for col in range(256)] for row in range(256)]
def analyseLine(ip_line):
    ip_str_list = ip_line.split('|')
    if len(ip_str_list) < 7:
        return 0,0,0,0,0
    ip_nation,ip_version,ip_str,ip_num = ip_str_list[1],ip_str_list[2],ip_str_list[3],int(ip_str_list[4])
    if ip_nation!='CN' or ip_version!='ipv4':
        return 0,0,0,0,0
    ip_addr = ip_str.split('.')
    if len(ip_addr) < 4:
        return 0,0,0,0,0
    addr1,addr2,addr3,addr4 = int(ip_addr[0]),int(ip_addr[1]),int(ip_addr[2]),int(ip_addr[3])
    return addr1,addr2,addr3,addr4,ip_num


def init_ip_dict(frome_file):
    global global_ip_dict
    if not os.path.isfile(frome_file):
        frome_file = os.path.join(os.path.dirname(__file__), frome_file)
    try:
        filedes = open(frome_file, 'r')
    except:
        return False
    lines = filedes.readlines()
    for line in lines:
        addr1,addr2,addr3,addr4,number_sum = analyseLine(line)
        if number_sum == 0:
            continue
        
        offset = 0
        while number_sum > 0:
            if number_sum >= 65536:
                start,end,number = 0,65535,65536
            else:
                start = addr3*256 + addr4
                end = start + number_sum -1
                number = number_sum
            global_ip_dict[addr1][addr2+offset].append({'start':start,'end':end,'number':number})
            number_sum -= 65536
            offset += 1
    filedes.close()
    return True

def isChinaIP(ip):
    global global_ip_dict
    ip_addr = ip.split('.')
    if len(ip_addr) < 4:
        return False
    addr1,addr2,addr3,addr4 = int(ip_addr[0]),int(ip_addr[1]),int(ip_addr[2]),int(ip_addr[3])

    if len(global_ip_dict[addr1][addr2]) == 0:
        return False
    addr_value = addr3*256+addr4
    for item in global_ip_dict[addr1][addr2]:
        if addr_value >= item['start'] and addr_value <= item['end']:
            return True
    return False


init_ip_dict('delegated-apnic-latest.txt')


if __name__=="__main__":
    
    print(isChinaIP('27.0.160.4'))
    
if __name__ == "__main__1" :
    ip = Argv('-ip')
    dat = Argv('-dat')
    main(ip, dat)



