#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# editor: mufei(ypdh@qq.com tel:15712150708)
'''
牧飞 _ __ ___   ___   ___  / _| ___(_)
| '_ ` _ \ / _ \ / _ \| |_ / _ \ |
| | | | | | (_) | (_) |  _|  __/ |
|_| |_| |_|\___/ \___/|_|  \___|_|
'''
#+--------------------------------------------------------------------
#|   宝塔第三方应用开发 mfngxwaf
#+--------------------------------------------------------------------

__all__ = ['mfngxwaf_main']

import sys,os,json,re,time
import psutil
import requests

try:
    from urllib.parse import unquote
except:
    from urllib import unquote

#设置运行目录
basedir = os.path.abspath(os.path.dirname(__file__))
plugin_path = basedir

'''
document_root:/www/wwwroot/bt.mufei.com
remote_port:65454
request_filename:/www/wwwroot/bt.mufei.com/xxx/a.php
'''
    

if __name__ != '__main__':
    #添加包引用位置并引用公共包
    sys.path.append("class/")
    import public
    from BTPanel import cache,session
    for tmp in ['/www/server/panel/plugin/mfngxwaf/accesslog.py',
            '/www/server/panel/plugin/mfngxwaf/accesslog.pyc',
            ]:
        if os.path.isfile(tmp): os.remove(tmp)

    if os.path.isfile('/www/server/panel/plugin/mflogview/qqwry.dat'):
        if 'plugin/mflogview/' not in sys.path:
            sys.path.append("plugin/mflogview/")
        from mflogview_main import NgxLog
    else:
        NgxLog = None

    #设置缓存(超时10秒) cache.set('key',value,10)
    #获取缓存 cache.get('key')
    #删除缓存 cache.delete('key')

    #设置session:  session['key'] = value
    #获取session:  value = session['key']
    #删除session:  del(session['key'])

try:
    from IPy import IP
except:
    print(os.popen('pip install IPy').read())
    

int_ip = lambda x: '.'.join([str(x/(256**i)%256) for i in range(3,-1,-1)])
ip_int = lambda x:sum([256**j*int(i) for j,i in enumerate(x.split('.')[::-1])])
def get_ips(ip1,ip2):
    f=open('ips.txt','w')
    ip1_num = ip_int(ip1)
    ip2_num = ip_int(ip2)
    for i in range(ip1_num,ip2_num+1):
        f.write(str(int_ip(i))+'\n')
#get_ips('192.168.0.0','192.168.255.255')

def checkIP(ip, one=0, d=None):
    if one:
        p = r"^(\d+)[.](\d+)[.](\d+)[.](\d+)$"
    else:
        p = r"^(\d+)[.](\d+)[.](\d+)[.](\d+)\/(\d+)?$"
    rs = re.findall(p, ip.strip())
    if rs:
        
        rs = [int(e or 0) for e in rs[0]]
        if rs[0]>255 or rs[1]>255 or rs[2]>255 or rs[3]>255:
            return ip+" :error"
        elif rs[0]<1 or rs[1]<0 or rs[2]<0 or rs[3]<0:
            return ip+" :error"
        elif len(rs)==4 or not rs[4]:
            pass
        elif rs[4]<16 or rs[4]>32:
            return ip+" :error in /(16-32)"
    else:
        return ip+" :error ip"
    if d is not None: 
        pass
        
 
def checkTxt(path, isip=0, isre=0):
    if not os.path.isfile(path):
        return ''
    txt = open(path).read()
    txt = re.sub('<!--[\s\S]*?-->', ' ', txt)
    L = []
    for line in txt.split('\n'):
        s = line.split('#')[0].strip()
        if s: L.append(s)
    if isip:
        for s in L:
            if s[0]=='(': s=s[1:-1]
            if '|' in s:
                ss = s.split('|')
            else:
                ss = [s]
            for e in ss:
                e = e.strip()
                if '-' in e:
                    e1,e2 = e.split('-', 1)
                    err = checkIP(e1.strip(), 1)
                    if err: return err
                    err = checkIP(e2.strip(), 1)
                    if err: return err
                    continue
                if '/' in e:
                    err = checkIP(e)
                    if err: return err
                    try:
                        IP(e)
                    except :
                        return e+" :error in /(16-32)"
                else:
                    err = checkIP(e, 1)
                    if err: return err
    elif isre:
        for s in L:
            try:
                m = re.search(s,'')
            except:
                return s+" in error python-re"
            
        
            
            


class mfngxwaf_main:
    __plugin_path = plugin_path
    __config = None
    __mfwafPath = "/www/server/nginx/mfwaf"
    __mfwafnet_pro_shell = "ps -ef |grep mfwafnet.py |grep -v grep | awk '{print $2}'"
    version = "1.6.11"

    def get_mfwafnet_pro(self):
        L = public.ExecShell(self.__mfwafnet_pro_shell)
        L = L[0].strip(),L[1]
        return L

    def start_mfwafnet(self, args):
        pro = self.get_mfwafnet_pro()
        if pro[0]:
            return {'msg':"程序已运行，无需启动", "status":0}
        s = "export PATH=/www/server/panel/pyenv/bin:$PATH && nohup python /www/server/panel/plugin/mfngxwaf/mfwafnet.py >>/www/server/panel/plugin/mfngxwaf/mfwafnet.log 1> &2 &"
        s = "export PATH=/www/server/panel/pyenv/bin:$PATH && nohup python /www/server/panel/plugin/mfngxwaf/mfwafnet.py >/dev/null 2>&1 &"
        
        L = public.ExecShell(s)
        #print(L)
        return {'msg':"程序已经启动", "status":1}
        
        
    def stop_mfwafnet(self, args):
        pro = self.get_mfwafnet_pro()
        if pro[0]:
            L = public.ExecShell("kill -9 %s"%(pro[0]))
            print(L)
            with open('/www/server/panel/plugin/mfngxwaf/mfwafnet.log', 'a') as f:
                f.write('\n'+time.ctime()+' Mfwaf Monitor closed .\n')
            time.sleep(0.5)
        port = int(self.__config.get('port') or '9494')
        cmd = 'lsof -n -i:%s'%port
        L = os.popen(cmd).read()
        if L:
            with open('/www/server/panel/plugin/mfngxwaf/mfwafnet.log', 'a') as f:
                f.write('\n'+time.ctime()+' Mfwaf Monitor closed More.\n')
            for e in L.split('\n')[1:]:
                m = re.search('\s\d+\s',e)
                if m:
                    p = m.group().strip()
                    public.ExecShell("kill -9 %s"%p)
                
        
        
        return {'msg':"程序已经关闭", "status":1}
    
    

    #构造方法
    def  __init__(self):
        ""
        self.__config = self.__get_config() or {'cc':{}}
        xx = self.__config.setdefault('xx', {})
        
        if xx.get('x4') is None:
            xx['x4'] = 1

    def check_txts(self, args):
        for t in ('ipblacks.txt','ipwhites.txt','ipcdns.txt','ipzhizhu.txt'):
            pth = os.path.join(self.__mfwafPath, 'conf',t)
            R = checkTxt(pth, isip=1)
            if R:
                return {"msg":t+" ERR: "+R,"status":0}
        for t in ('uriblacks.txt','uablacks.txt'):
            pth = os.path.join(self.__mfwafPath, 'conf',t)
            R = checkTxt(pth, isre=1)
            if R:
                return {"msg":t+" ERR: "+R,"status":0}
        
        return {"msg":"左侧名单检测OK","status":1}

    def get_ips(self, args):
        #/plugin?action=a&s=get_ips&name=mfngxwaf&mf_tp=config
        
        mf_tp =  args.mf_tp.strip()
        import requests
        if mf_tp in ('ipgreys','ipvalids','ipblues', 'config'):
            try:
                rs = requests.get("http://127.0.0.1/mfwaf-%s"%mf_tp).json()
                rs = {'status':1, 'data':rs}
            except:
                rs = {'status':0, 'msg':"请求错误，请检查ngx或mfWaf防火墙是否开启"}
            if rs.get('status'):
                rs['msg'] = "操作成功"
            return rs
            
        
        
        
    def waf_reload(self, args):
        import requests
        try:
            rs = requests.get("http://127.0.0.1/mfwaf-reload").json()
        except:
            msg = "配置不存在或未开启mfWaf防火墙<br>请检查nginx配置(/www/server/nginx/conf/nginx.conf)是否存在python_include和python_access,填写请看论坛信息"
            rs = {'status':0, 'msg':msg}
        if rs.get('status'):
            rs['msg'] = "操作成功"
        return rs

    def getsrcips(self, args):
        txts = args.txts.strip()
        m=re.findall('(\d+[.]\d+[.](\d+|[*])[.](\d+|[*])(/\d+)?)', txts)
        
        d = {}
        
        for e in m:
            ip = e[0]
            if '*' not in ip: d[ip] = 1
            elif '/' in ip:
                ip = ip.replace('*','0')
                d[ip] = 1
            elif ip.count('*')==1:
                ip = ip.replace('*','0')+'/24'
                d[ip] = 1
            elif ip.count('*')==2:
                ip = ip.replace('*','0')+'/16'
                d[ip] = 1
        s = '\n'.join(d)
        return {'status':1, 'result':d, 'txt':s}
            
    
    def save_conf(self, args):
        r0 = args.r0.strip()
        r0a = int(args.r0a) if "r0a" in args else 0
        
        r1 = int(args.r1.strip() or '0')
        r2 = int(args.r2.strip() or '0')
        r3 = int(args.r3.strip() or '0')
        r4 = int(args.r4.strip() or '0')
        r5 = int(args.r5.strip() or '0')
        r6 = int(args.r6.strip() or '0')
        r7 = int(args.r7.strip() or '0')
        r8 = int(args.r8.strip() or '0')
        r9 = int(args.r9.strip() or '0')
        r109 = int(args.r109.strip() or '0')
        
        r10 = int(args.r10) if "r10" in args else 0
        r110 = args.r110.strip()

        a0 = args.a0.strip() if "a0" in args else ''
        a1 = args.a1.strip() or ''
        a2 = int(args.a2.strip() or '0')
        a3 = int(args.a3) if "a3" in args else 0
        a4 = int(args.a4.strip() or '0') or 4
        a5 = args.a5.strip() or ''
        a6 = args.a6.strip() or ''
        a6a = int(args.a6a) if "a6a" in args else 0
        
        b1 = int(args.b1) if "b1" in args else 0
        b1a = int(args.b1a) if "b1a" in args else 0

        c0 = args.c0.strip() if "c0" in args else ''
        
        c1 = int(args.c1) if "c1" in args else 0
        c2 = args.c2.strip() or ''
        
        d1 = int(args.d1) if "d1" in args else 0
        d1a = int(args.d1a) if "d1a" in args else 0
        
        d2 = args.d2.strip() or ''
        d21 = int(args.d21) if "d21" in args else 0
        d3 = args.d3.strip() or ''
        d4 = args.d4.strip() or ''
        d6 = int(args.d6) if "d6" in args else 0
        d7 = args.d7.strip() or ''
        
        e1 = int(args.e1.strip() or '0')
        e2 = int(args.e2.strip() or '0')
        e3 = int(args.e3.strip() or '0')
        e5 = int(args.e5.strip() or '0')
        e6 = int(args.e6.strip() if "e6" in args else '0')

        e101 = int(args.e101) if "e101" in args else 0
        e102 = int(args.e102) if "e102" in args else 0
        e103 = int(args.e103) if "e103" in args else 0
        e104 = int(args.e104) if "e104" in args else 0
        e105 = int(args.e105) if "e105" in args else 0
        e106 = int(args.e106) if "e106" in args else 0
        e107 = int(args.e107) if "e107" in args else 0
        e108 = int(args.e108) if "e108" in args else 0

        f1 = int(args.f1) if "f1" in args else 0
        f2 = int(args.f2.strip() or '0')
        f3 = int(args.f3) if "f3" in args else 0

        err = None
        if   0<r2<r1:
            err = {"msg":"规则2的值应该大于规则1","status":0}
        elif 0<r4<r3:
            err = {"msg":"规则4的值应该大于规则3","status":0}
        elif 0<r8<r7:
            err = {"msg":"规则8的值应该大于规则7","status":0}
        elif 0<r7<r1:
            err = {"msg":"规则7的值应该大于规则1","status":0}
        elif 0<r8<r2:
            err = {"msg":"规则8的值应该大于规则2","status":0}
        elif 0<e1<1000:
            err = {"msg":"规则E请求数不能少于1000","status":0}
        elif c0 and len(c0)<16:
            err = {"msg":"规则C0 API密钥不能少于16位","status":0}
        if err:
            return err
        if c2:
            try:
                re.search(c2, "")
            except:
                return {"msg":"C)正则输入错误","status":0}
        if d2:
            try:
                _d2 = '(%s)$'%d2
                re.search(_d2, "")
            except:
                return {"msg":"D)规则域名输入错误","status":0}
        if d3:
            try:
                re.search(d3, "")
            except:
                return {"msg":"D)URL正则输入错误","status":0}
        if d4:
            try:
                re.search(d4, "")
            except:
                return {"msg":"D)UA正则输入错误","status":0}
        if a0:
            try:
                re.search(a0, "")
            except:
                return {"msg":"A0正则输入错误","status":0}
            
        
        d = {'r0':r0,'r0a':r0a,
             'r1':r1,
             'r2':r2, 'r3':r3, 'r4':r4,'r5':r5,'r6':r6, 'a6a':a6a,
             'r7':r7,'r8':r8,
             'r9':r9, 'r109':r109, 'r10':r10, 'r110':r110,
             'a0':a0, 'a1':a1, 'a2':a2, 'a3':a3,'a4':a4, 'a5':a5, 'a6':a6, 
             'b1':b1, 'b1a':b1a, 'c0':c0, 'c1':c1, 'c2':c2,
             'd1':d1, 'd2':d2, 'd3':d3, 'd4':d4, 'd6':d6, 'd7':d7, 'd21':d21,  'd1a':d1a,
             'e1':e1, 'e2':e2, 'e3':e3, 'e5':e5, 'e6':e6,
             'e101':e101, 'e102':e102, 'e103':e103, 'e104':e104, 'e105':e105, 'e106':e106, 'e107':e107, 'e108':e108,
             'f1':f1, 'f2':f2, 'f3':f3
             }
        self.__set_config('cc',d)

        return {"msg":"CC防御设置保存成功","status":1}
    
    
    def save_ii_conf(self, args):
        
        i1 = int(args.i1.strip() or '0')
        i2 = int(args.i2.strip() or '0')
        i3 = int(args.i3) if "i3" in args else 0
        
        i11 = int(args.i11.strip() or '0')
        i12 = int(args.i12.strip() or '0')

        i41 = int(args.i41) if "i41" in args else 0
        i42 = int(args.i42) if "i42" in args else 0
        i43 = int(args.i43) if "i43" in args else 0
        i44 = int(args.i44) if "i44" in args else 0
        
        
        i5 = int(args.i5) if "i5" in args else 0
        i5a = int(args.i5a) if "i5a" in args else 0

        i6 = int(args.i6) if "i6" in args else 0
        i6a = int(args.i6a) if "i6a" in args else 0
        i6b = int(args.i6b) if "i6b" in args else 0
        i6c = int(args.i6c) if "i6c" in args else 0
        i6d = int(args.i6d) if "i6d" in args else 0
        i6e = int(args.i6e) if "i6e" in args else 0
        i6f = int(args.i6f) if "i6f" in args else 0
        i6g = int(args.i6g) if "i6g" in args else 0
        i6h = int(args.i6h) if "i6h" in args else 0


        i61a = int(args.i61a) if "i61a" in args else 0
        i61b = int(args.i61b) if "i61b" in args else 0
        i61c = int(args.i61c) if "i61c" in args else 0
        i61d = int(args.i61d) if "i61d" in args else 0
        i61e = int(args.i61e) if "i61e" in args else 0
        i61f = int(args.i61f) if "i61f" in args else 0
        i61g = int(args.i61g) if "i61g" in args else 0
        i61h = int(args.i61h) if "i61h" in args else 0
        
        i7 = int(args.i7) if "i7" in args else 0
        i8 = int(args.i8) if "i8" in args else 0
        i9 = int(args.i9) if "i9" in args else 0
        
        d = {'i1':i1,'i11':i11,
             'i2':i2, 'i12':i12, 
             'i3':i3,
             'i41':i41,'i42':i42,'i43':i43,'i44':i44,
             'i5':i5,'i5a':i5a, 'i7':i7,
             'i6':i6, 'i6a':i6a, 'i6b':i6b, 'i6c':i6c, 'i6d':i6d, 'i6e':i6e, 'i6f':i6f, 'i6g':i6g, 'i6h':i6h,
             'i61a':i61a, 'i61b':i61b, 'i61c':i61c, 'i61d':i61d, 'i61e':i61e, 'i61f':i61f, 'i61g':i61g, 'i61h':i61h, 
             'i8':i8, 'i9':i9
            
             }
        self.__set_config('ii',d)

        return {"msg":"IPset防御设置","status":1}


    def save_kk_conf(self, args):
        kk = self.__config.setdefault('kk',{})
        k0 = args.k0.strip()
        kk['k0'] = k0
        if k0=="cloudflare":
            kk[k0] = d = {'email':args.email.strip(),
                      'api_key':args.api_key.strip(),
                      'zone_id':args.zone_id.strip(),
                      'autoblock':int(args.autoblock) if "autoblock" in args else 0,
                      'high_5s':int(args.high_5s) if "high_5s" in args else 0,
                      'no_5s':int(args.no_5s) if "no_5s" in args else 0,
                     }
        elif k0=="baidusu":
            kk[k0] = d = {'access_key':args.access_key.strip(),
                      'secret_key':args.secret_key.strip(),
                      'domain':args.domain.strip(),
                      'autoblock':int(args.autoblock) if "autoblock" in args else 0,
                      'high_5s':int(args.high_5s) if "high_5s" in args else 0,
                      'no_5s':int(args.no_5s) if "no_5s" in args else 0,
                     }
        elif k0=="othercdn":
            kk[k0] = d = {'blackcmd':args.blackcmd.strip(),
                      
                     }
            
        self.__set_config('kk',kk)
        
        return {"msg":"保存设置成功","status":1}

    def save_ss_conf(self, args):
        ss = self.__config.setdefault('ss',{})
        d = {'email':args.email.strip(),
             'mins':int(args.mins.strip() or '5'),
             's1':int(args.s1) if "s1" in args else 0,
            }
        
            
        self.__set_config('ss',d)
        
        return {"msg":"保存设置成功","status":1}

    def save_xx_conf(self, args): #兼容
        x1 = int(args.x1) if "x1" in args else 0
        x2 = int(args.x2) if "x2" in args else 0
        x3 = int(args.x3) if "x3" in args else 0
        x4 = int(args.x4) if "x4" in args else 0
        x5 = int(args.x5) if "x5" in args else 0
        x6 = int(args.x6) if "x6" in args else 0
        x7 = int(args.x7) if "x7" in args else 0
        x8 = int(args.x8) if "x8" in args else 0
        x9 = int(args.x9) if "x9" in args else 0
        x10 = int(args.x10) if "x10" in args else 0
        
        x11 = int(args.x11) if "x11" in args else 0
        x12 = int(args.x12) if "x12" in args else 0
        x13 = int(args.x13) if "x13" in args else 0
        x14 = int(args.x14) if "x14" in args else 0
        x15 = int(args.x15) if "x15" in args else 0
        x16 = int(args.x16) if "x16" in args else 0
        x17 = int(args.x17) if "x17" in args else 0
        x18 = int(args.x18) if "x18" in args else 0
        x19 = int(args.x19) if "x19" in args else 0
        

        x100 = int(args.x100) if "x100" in args else 0
        x101 = int(args.x101) if "x101" in args else 0
        x102 = int(args.x102) if "x102" in args else 0
        x103 = int(args.x103) if "x103" in args else 0
        x104 = int(args.x104) if "x104" in args else 0
        x105 = int(args.x105) if "x105" in args else 0
        
        d = {'x1':x1,'x2':x2,'x3':x3,'x4':x4,'x5':x5,'x6':x6,'x7':x7,'x8':x8,'x9':x9,'x10':x10,
             'x11':x11,'x12':x12,'x13':x13,'x14':x14,'x15':x15,'x16':x16,'x17':x17,'x18':x18,'x19':x19, 
             'x100':x100, 'x101':x101, 'x102':x102, 'x103':x103, 'x104':x104,
             'x105':x105
             }
        self.__set_config('xx',d)

        return {"msg":"兼容设置成功","status":1}
    
    
    def save_mm_conf(self, args):
        port = int(args.port.strip() or '9494')
        self.__set_config('port',port)
        
        m1 = int(args.m1.strip() or '0')
        m2 = int(args.m2.strip() or '0')
        m11 = int(args.m11.strip() or '0')
        m21 = args.m21.strip()
        
        m3 = int(args.m3.strip() or '0')
        m4 = int(args.m4.strip() or '0')
        m13 = int(args.m13.strip() or '0')
        m23 = args.m23.strip()

        m5 = int(args.m5.strip() or '0')
        m5a = int(args.m5a.strip() or '0')
        m15 = int(args.m15.strip() or '0')

        m6 = int(args.m6) if "m6" in args else 0
        m16 = args.m16.strip()
        m26 = args.m26.strip()
        

        m7 = int(args.m7) if "m7" in args else 0
        m17 = args.m17.strip()
        m27 = int(args.m27) if "m27" in args else 0
        m37 = args.m37.strip()
        
        m8 = args.m8.strip()
        m18 = args.m18.strip()

        m9 = int(args.m9.strip() or '0')
        m10 = int(args.m10) if "m10" in args else 0
        
        d = {'m1':m1,'m11':m11, 'm21':m21,
             'm2':m2,
             
             'm3':m3,'m13':m13, 'm23':m23,
             'm4':m4,

            'm5':m5, 'm15':m15, 'm5a':m5a,
            'm6':m6,'m16':m16,'m26':m26,
            'm7':m7,'m17':m17,'m27':m27,'m37':m37,
            "m8":m8, "m18":m18,
            'm9':m9, 
            "m10":m10
             
             }
        self.__set_config('mm',d)

        return {"msg":"流量监控设置","status":1}
    
    
    def index(self, args):
        isextcfg = os.path.isfile('/www/server/nginx/mfwaf/conf/mfwaf.ext.conf')
            
        return {'conf':self.__config, 'isextcfg':isextcfg}
        
    def bases(self, args):
        open('/www/server/panel/plugin/mfngxwaf/loginip','w').write(args.client_ip)
        fpath = "/www/server/panel/plugin/mfngxwaf/mfngxwaf.version"
        ver = None
        if os.path.isfile(fpath) and time.time()-os.path.getmtime(fpath)<3600:
            try:
                ver = json.load(open(fpath))
            except:
                pass
                
        if ver is None:
            try:
                headers={
                    "Host": "www.mufei.ltd",
                    "User-Agent":"Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36"
                    }
                ver = requests.get('http://www.mufei.ltd/mfngxwaf/version.json',headers=headers, timeout=3).json()
                
                if [int(e) for e in self.version.split('.')]>=[int(e) for e in ver['version'].split('.')]:
                    ver = None   
                else:
                    open(fpath,'wb').write(json.dumps(ver))
            except:
                ver = None
        else:
            if [int(e) for e in self.version.split('.')]>=[int(e) for e in ver['version'].split('.')]:
                ver = None 

        k0 = self.__config.setdefault('kk',{}).get('k0','cloudflare')
        
        isipproblem = os.path.isfile('/www/server/nginx/mfwaf/conf/ipproblem.txt')
        isareablacks = os.path.isfile('/www/server/nginx/mfwaf/conf/areablacks.txt')
        return {'ver':ver, 'kk_k0':k0, 'isipproblem':isipproblem, 'isareablacks':isareablacks}


    def ipset(self, args):
        return {'conf':self.__config}
    def cloudflare(self, args):
        return {'conf':self.__config}
    def baidusu(self, args):
        return {'conf':self.__config}
    def othercdn(self, args):
        return {'conf':self.__config}
    
    def moveattr(self, args):
        os.popen('chattr -iR /www/wwwroot')
        return {'status':1, 'msg':'解锁成功'}
    
    def netio(self, args):
        netio_proc = self.get_mfwafnet_pro()
        try:
            nets = dict([(k.decode('GBK'),1) for k in psutil.net_if_addrs().keys()]) #psutil.net_if_addrs()
        except:
            nets = dict([(k,1) for k in psutil.net_if_addrs().keys()])
        
            
        return {'conf':self.__config, 'netio_proc':netio_proc, 'nets':nets}
        
        
    def compatible(self, args):
        
        return {'conf':self.__config}
    
    def greys(self, args):
        rs = {}
        txt = os.popen('ipset list mfwaf404').read()
        L=re.findall('(\d+(?:[.]\d+){3})\s+timeout\s+\d+', txt)
        rs = dict([(ip,100) for ip in L])
        
        import requests
        try:
            rs.update(requests.get("http://127.0.0.1/mfwaf-ipgreys").json())
        except:
            pass
        return rs
   
    def blues(self, args):
        import requests
        try:
            return requests.get("http://127.0.0.1/mfwaf-ipblues").json()
        except:
            return {}

    def view_access_log(self, args):
        logpath = args.logpath if 'logpath' in args else ""
        isview = 1 if os.path.isdir("/www/server/panel/plugin/mflogview") else 0
        isview2 = 1 if os.path.isdir("/www/server/panel/plugin/mflog") else 0
        return  {'isview':isview,'isview2':isview2, 'logpath':logpath}
    def view_list_log(self, args):
        logpath = args.logpath if 'logpath' in args else ""
        isview = 1 if os.path.isdir("/www/server/panel/plugin/mflogview") else 0
        isview2 = 1 if os.path.isdir("/www/server/panel/plugin/mflog") else 0
        return  {'isview':isview,'isview2':isview2, 'logpath':logpath}
    
    def check_mfwaf(self, args):
        fpth = os.path.join(basedir, 'ngx.py')
        errpth = os.path.join(basedir, 'error')
        open(fpth,'w').close()
        error = os.popen('python /www/server/panel/plugin/mfngxwaf/wafnet.py > /www/server/panel/plugin/mfngxwaf/error 2>&1 &').read()
        if not error:
            error = open(errpth).read()
        if not error and not os.path.isfile('/www/server/nginx/mfwaf/mfngxwaf.py'):
            error = "安装或导入未成功"
        if not error :
            s = open('/www/server/nginx/conf/nginx.conf').read()
            if not re.search(r'\binclude\s+mfngxwaf.conf\s*;', s):
                error = "配置文件nginx.conf没有配置添加 include mfngxwaf.conf; "
        if not error: 
            if not re.search('\s*worker_processes\s+1\s*\;', open('/www/server/nginx/conf/nginx.conf','r').read()):
                error = "配置文件nginx.conf请配置worker_processes值为1; "

        try:
            os.remove(fpth)
            os.remove(fpth+'c')
        except:
            pass
        
            
        return {"msg":error,"status":0} if error else {"msg":"检测无错误","status":1}
        
    def import_out_conf(self, args):
        import zipfile
        fpath = '/www/server/nginx/mfwaf/mfwaf.cfg.%d.zip'%(time.time())
        try:
            zfile = zipfile.ZipFile(fpath, "w", compression=zipfile.ZIP_DEFLATED)
        except:
            return {"msg":"压缩文件zip创建失败","status":0}
        files = ('config.json',
                 'conf/captcha.txt',
                 'conf/ipblacks.txt',
                 'conf/areablacks.txt',
                 'conf/ipcdns.txt',
                 'conf/ipwhites.txt',
                 'conf/ipzhizhu.txt',
                 'conf/uablacks.txt',
                 'conf/mfwaf.ext.conf',
                 'conf/ipproblem.txt',
                 'conf/uriblacks.txt',
                 'html/pass.html',
                 'html/sign.html',
                 'html/captcha.html'
                 )
        rootpath = '/www/server/nginx/mfwaf'
                
        for f in files:
            f=f.strip('/')
            f1 = os.path.join(rootpath, f)
            if not os.path.isfile(f1): continue
            zfile.write(f1, f)  
        zfile.close()
        return {"msg":"OK",'path':fpath, "status":1}

    def import_in_conf(self, args):
        from flask import request
        content = request.files['zip'].read()
        zip = '/www/server/nginx/mfwaf/update.zip'
        open(zip, 'wb').write(content)
        
        #print request.files
        #print content
        
        import zipfile
        rootpath = '/www/server/nginx/mfwaf'
        zfile = zipfile.ZipFile(zip,'r')
        
        rs = []
        for filename in zfile.namelist():
            f = os.path.join(rootpath,  filename)
            if os.path.isfile(f):
                f2 = f+'.bak'
                if os.path.isfile(f2): os.remove(f2)
                os.rename(f, f2)
                rs.append(f2)
            
            data = zfile.read(filename)
            try:
                file = open(f, 'w+b')
            except IOError:
                fpath = os.path.abspath(os.path.join(f,".."))
                if not os.path.exists(fpath):
                    os.makedirs(fpath)
                    file = open(f, 'w+b')
            file.write(data)
            file.close()
        os.popen('chown -R www.www  /www/server/nginx/mfwaf')
        
        return {"msg":u"导入成功","status":1}

    def del_blue_ip(self,args):
        ip = args.ip
        url = "http://127.0.0.1/mfwaf-api?fn=del_blue_ip&ip=%s"%ip
        vpath = '/www/server/nginx/mfwaf/valids/'+ip
        
        if os.path.isfile(vpath): os.remove(vpath)
        
        import requests
        try:
            rs = requests.get(url).json()
        except:
            msg = "操作失败"
            rs = {'status':0, 'msg':msg}
        if rs.get('status'):
            rs['msg'] = "操作成功"
        return rs

    def del_grey_ip(self,args):
        ip = args.ip
        url = "http://127.0.0.1/mfwaf-api?fn=del_grey_ip&ip=%s"%ip
        import requests
        try:
            rs = requests.get(url).json()
            os.popen('ipset del mfwaf404 %s'%ip)
        except:
            msg = "操作失败"
            rs = {'status':0, 'msg':msg}
        if rs.get('status'):
            rs['msg'] = "操作成功"
        return rs



    def test_cloudflare(self, args):
        from wafnet import CloudFlare
        _kk = self.__config.setdefault('kk',{})
        _kk0 = _kk.get('k0')
        rs = {'status':0, 'msg':'error'}
        if _kk0=='cloudflare':
            tmp = _kk['cloudflare']
            if tmp['email'] and tmp['api_key'] and tmp['zone_id'] :
                cloudflare = CloudFlare(tmp['email'], tmp['api_key'] , tmp['zone_id'])
                print(cloudflare)
                #_rs = cloudflare and cloudflare.firewall('192.168.100.100')
                _rs = cloudflare and cloudflare.api_under_attack('low')
                rs = {'status':1, 'msg':str(_rs)}
        return rs

    def test_baidusu(self, args):
        from wafnet import Baidusu
        _kk = self.__config.setdefault('kk',{})
        _kk0 = _kk.get('k0')
        rs = {'status':0, 'msg':'error'}
        if _kk0=='baidusu':
            tmp = _kk['baidusu']
            if tmp['domain'] and tmp['access_key'] and tmp['secret_key'] :
                baidusu = Baidusu(tmp['domain'], tmp['access_key'] , tmp['secret_key'])
                print(baidusu)
                #_rs = baidusu and baidusu.firewall('192.168.100.100')
                _rs = baidusu and baidusu.waf()
                rs = {'status':1, 'msg':str(_rs)}
        return rs
    
    def nginx_restart(self, args):
        msg = os.popen('service nginx restart').read()
        rs = {'status':1,'msg':msg or 'OK'}
        return rs


    def mfwaftest(self, args):
        url = "http://127.0.0.1/mfwaf-api?fn=allow_test"
        txts = args.txts.strip()
        m=re.findall(r'[\w-]+', txts)[:20]
        keys = ','.join(m)
        import requests
        from flask import request
        try:
            rs = requests.get(url).json()
        except:
            pass
        url = 'http://'+request.host.split(':')[0]+'/mfwaf-test?keys='+keys
        rs = {'status':1,
              'msg': 'OK',
              'url':url
            }
        return rs
        
    def message(self, args):
        return {'conf':self.__config}

    def getIpInfo(self, args):
        ip = args.ip.strip()
        address = NgxLog.getIpInfo(ip)
        if address:
            rs = {'data':{'country':address}}
            return json.dumps(rs)
        
        
    def __get_config(self,key=None,force=False):
        if not self.__config or force:
            config_file = self.__mfwafPath + '/'+ 'config.json'
            if not os.path.exists(config_file): return None
            f_body = public.ReadFile(config_file)
            if not f_body: return None
            self.__config = json.loads(f_body)
            
        if key:
            if key in self.__config: return self.__config[key]
            return None
        
        return self.__config


    def __set_config(self,key=None,value=None):
        if not self.__config: self.__config = {'cc':{},'mm':{}, 'ii':{}} 
        self.__config[key] = value
            
        config_file = self.__mfwafPath +'/'+ 'config.json'
        public.WriteFile(config_file,json.dumps(self.__config))
        
        return True

    






        
        
    
    
        
    

