#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# editor: mufei(ypdh@qq.com tel:15712150708)
'''
牧飞 _ __ ___   ___   ___  / _| ___(_)
| '_ ` _ \ / _ \ / _ \| |_ / _ \ |
| | | | | | (_) | (_) |  _|  __/ |
|_| |_| |_|\___/ \___/|_|  \___|_|
'''

import sys
py = list(sys.version_info)
try:
    if py[0]==2:
        from wafnet27 import *
        from wafnet27 import _port_is_free
    elif py[1]==6:
        from wafnet36 import *
        from wafnet36 import _port_is_free
    elif py[1]==7:
        from wafnet37 import *
        from wafnet37 import _port_is_free
    elif py[1]==8:
        from wafnet38 import *
        from wafnet38 import _port_is_free
except:
    from wafnet import *
    from wafnet import _port_is_free
    

set_wafnet()


app = Flask(__name__)



@app.route('/ipset')
def ipset():
    ip = request.args.get('ip', '')
    m = request.args.get('m', '')
    v = request.args.get('v', '')
    if v and v.isdigit():
        v = int(v)
    
    rs = time.ctime()
    if ip and m:
        rs = mfwaf404(ip,m) or "OK"
        if v and v>20:
            Mail and int(m.split('.')[0])>100 and Mail.method('ipset',conf, ip)
    else: rs = "no ip or m"
    return str(rs)

started = 0
if __name__ == '__main__':
    port = conf.get('ipsetport') or '9494'
    
    if not _port_is_free(port) and not started:
        print("port端口已占用--exit")
        logging.debug("port端口已占用")
        open(profile,'a+').write('port error! %s\n'%time.ctime())
        sys.exit(1)
    
    print('start mfngxwaf/mfwafnet')
    if fcntl:  
        fli = os.path.join(basedir,'mfwafnet.lock')
        fl = open(fli, "w")
        try:
            fcntl.flock(fl, fcntl.LOCK_EX | fcntl.LOCK_NB) #写锁
            fl.write(str(os.getpid()))
            fl.flush()
        except IOError:
            open(profile,'a+').write('mfwafnet lock error! %s\n'%time.ctime())
            print('locked exit')
            sys.exit(1)

    if "--debug" not in sys.argv:
        logging.basicConfig(
            filename='/www/server/panel/plugin/mfngxwaf/mfwafnet.log',
            level=logging.INFO,
            format='%(asctime)s  %(filename)s : %(levelname)s  %(message)s',  # 定义输出log的格式
            filemode='a',
            datefmt='%Y-%m-%d %A %H:%M:%S',
        )
        #logging.getLogger("requests").setLevel(logging.INFO)
        #logging.getLogger("urllib3").setLevel(logging.INFO)
        #logging.getLogger("requests.packages.urllib3").setLevel(logging.INFO)
        
    pidfile = "/var/run/mfwafnet.pid"    
    with open(pidfile, 'w') as f: 
        f.write(str(os.getpid()))
        f.flush()
        
    CronThread = threading.Thread(target=Cron,args=())
    CronThread.setDaemon(False)
    #error: cannot switch to a different thread (: needing monkey.patch_all())
    CronThread.start()

    _kk = conf.setdefault('kk',{})
    _kk0 = _kk.get('k0')
    if _kk0=='cloudflare':
        tmp = _kk['cloudflare']
        if tmp['email'] and tmp['api_key'] and tmp['zone_id'] and \
           (tmp.get('autoblock') or tmp.get('high_5s') or tmp.get('no_5s')):
            cloudflare = CloudFlare(tmp['email'], tmp['api_key'] , tmp['zone_id'])
            print(cloudflare)
    elif _kk0=='baidusu':
        tmp = _kk['baidusu']      
        if tmp['domain'] and tmp['access_key'] and tmp['secret_key'] and \
           (tmp.get('autoblock') or tmp.get('high_5s') or tmp.get('no_5s')):
            baidusu = Baidusu(tmp['domain'], tmp['access_key'] , tmp['secret_key'])
            print(baidusu)
    elif _kk0=="othercdn":
        othercdn = OtherCdn()
        print(othercdn)

    conf.setdefault('mm',{})
    if conf['mm'].get('m1') or conf['mm'].get('m2') or conf['mm'].get('m3') or conf['mm'].get('m4') or conf['mm'].get('m9'):
        IoCountThread = threading.Thread(target=net_io_counters,args=())
        IoCountThread.setDaemon(False)
        IoCountThread.start()
    
    

    if conf['mm'].get('m5') and conf['mm'].get('m15'):
        if conf['mm']['m5']<16: conf['mm']['m5']=16
        if conf['mm']['m15']>30: conf['mm']['m15']=30
        
        NetstatThread = threading.Thread(target=Netstat,args=())
        NetstatThread.setDaemon(False)
        NetstatThread.start()

    if conf['mm'].get('m6'):
        conf['mm']['m16'] = tuple([str(e.strip()) for e in (conf['mm']['m16'] or '.php').split('|')])
        conf['mm']['m26'] = tuple([e.strip().rstrip('/') for e in conf['mm']['m26'].replace('~/','/www/wwwroot/').split('|')])
        if len(conf['mm']['m26'])==1 and not conf['mm']['m26'][0]:
            conf['mm']['m26'] = ""
        ChattrThread = threading.Thread(target=Chattr,args=())
        ChattrThread.setDaemon(False)
        ChattrThread.start()
    
    if conf['mm'].get('m7'):
        if conf['mm'].get('m17'):
            conf['mm']['m17'] = tuple([str(e.strip()) for e in conf['mm']['m17'].split('|')])
        else:
            conf['mm']['m17'] = ('.php',)
        conf['mm']['m37'] = tuple([e.strip().rstrip('/') for e in conf['mm'].get('m37','').replace('~/','/www/wwwroot/').split('|')])
        if len(conf['mm']['m37'])==1 and not conf['mm']['m37'][0]:
            conf['mm']['m37'] = ""
        DirEventThread = threading.Thread(target=DirEvent,args=())
        DirEventThread.setDaemon(False)
        DirEventThread.start()
        
    conf.setdefault('ii',{})
    if (conf['mm'].get('m10') or cloudflare or conf['ii'].get('i3')) and ispyinotify:
        LoadavgThread = threading.Thread(target=Loadavg,args=())
        LoadavgThread.setDaemon(False)
        LoadavgThread.start()
    
    iptables()
    
    started = 1
    # Mail and Mail.method('loadavg', conf)
    if Mail : print('Mail message start')
    app.run(host='127.0.0.1',port=int(port), debug="--debug" in sys.argv)
    
    if fcntl: 
        fcntl.flock(fl, fcntl.LOCK_UN | fcntl.LOCK_NB)
        fl.close()
        os.remove(fli)
        
    try:
        os.remove(pidfile)
    except:
        pass
        
    print('exit')
    sys.exit(1)
    
    

